<template>
  <div :class="{ 'InputField--withLabel': !!label }" class="InputField">
    <label v-if="label" :for="uuid + '_select'" class="InputField__Label">
      {{ label }}
    </label>
    <!--suppress HtmlFormInputWithoutLabel -->
    <input
      :id="uuid + '_select'"
      :placeholder="placeholder || label"
      :value="modelValue"
      :type="type"
      class="InputField__Control"
      @input="change"
    />
    <Button
      v-if="isRestorable"
      icon="restore"
      class="InputField__Restore Button--noBorder"
      :title="t('component.restore')"
      @click="$emit('update:modelValue', restoreValue)"
    />
  </div>
</template>

<script lang="ts">
import { defineComponent, getCurrentInstance } from 'vue'
import Button from '@/components/Button.vue'

export default defineComponent({
  name: 'InputField',
  components: { Button },
  emits: ['update:modelValue'],
  props: {
    label: String,
    type: String,
    modelValue: null,
    restoreValue: null,
    noTranslate: Boolean,
    placeholder: String,
  },

  setup() {
    return {
      timeout: 0,
    }
  },

  computed: {
    isRestorable(): boolean {
      return this.restoreValue && this.restoreValue !== this.modelValue
    },
    uuid(): number {
      const cid = getCurrentInstance()
      if (cid) return cid.uid
      return -1
    },
  },

  methods: {
    change(event: InputEvent) {
      if (this.timeout) {
        clearTimeout(this.timeout)
      }
      this.timeout = window.setTimeout(
        () =>
          this.$emit(
            'update:modelValue',
            (event.target as HTMLInputElement).value
          ),
        300
      )
    },
  },
})
</script>

<style lang="scss" scoped>
@use '../../style/variables' as v;

.InputField {
  padding: 0;
  border-color: transparent;
  border-radius: v.$borderRadius;

  &--withLabel {
    border-color: var(--text-color);
  }

  &__Control {
    width: 100%;
    padding: v.$spacing/2 v.$spacing;
    border: none;
    background-color: transparent;
    color: var(--text-color);
  }
}
</style>
